<?php

namespace Drupal\Tests\widget_instance\Functional;

use Behat\Mink\Element\NodeElement;
use Drupal\Core\Url;
use Drupal\Tests\BrowserTestBase;

/**
 * Tests for the InteractiveComponents.
 *
 * @group widget_instance
 * @coversDefaultClass \Drupal\widget_instance\Controller\InteractiveComponents
 */
class InteractiveComponentsTest extends BrowserTestBase {

  /**
   * {@inheritdoc}
   */
  protected static $modules = ['widget_type', 'widget_instance'];

  /**
   * @covers ::__invoke
   *
   * @SuppressWarnings(PHPMD.StaticAccess)
   */
  public function testInvoke() {
    $this->drupalLogin($this->createUser([
      'administer widget_type entities',
      'administer widget_instance entities',
    ]));
    $this->drupalGet(Url::fromRoute('interactive_components'));
    $session = $this->getSession();
    $page = $session->getPage();
    $this->assertSame(200, $session->getStatusCode());
    $elements = (array) $page->findAll('css', 'li');
    $texts = array_map(function (NodeElement $element) {
      return $element->getText();
    }, $elements);
    $this->assertEquals(['Widget Types', 'Widget Instances'], $texts);
    $elements = (array) $page->findAll('css', 'p');
    $this->assertCount(2, $elements);
  }

}
